#ifndef CHESSY_CHESSGAME_H
#define CHESSY_CHESSGAME_H

#include <vector>

#include "Board.h"

namespace chessy
{
    class ChessGame;
}


class chessy::ChessGame
{
    Board board;

    bool canCastleQueenSideWhite =  true;
    bool canCastleQueenSideBlack =  true;
    bool canCastleKingSideWhite =   true;
    bool canCastleKingSideBlack =   true;

    short reversibleHalfMoves =     0;

    char enPassantRow =            -1;
    char turn =                     0;

    const static char WHITE =       0;
    const static char BLACK =       1;


public:
    ChessGame(void) = default;
    ChessGame(const ChessGame&) = default;
    ~ChessGame(void) = default;

    bool isValidMove(const Move& move) const;
    std::vector<Move> getValidMoves(void) const;
};

#endif // CHESSY_CHESSGAME_H

