#ifndef CHESSY_MOVEGENERATION_H
#define CHESSY_MOVEGENERATION_H 

#include "BitBoard.h"

namespace chessy
{
    struct Move;
    
    class PositionSet;

    class MoveGenerator;
}


struct chessy::Move
{
    Index origin;
    Index destination;
};


class chessy::PositionSet
{
    Bitboard bitboard;

    struct PositionSetIterator
    {
        Bitboard bitboard;

        inline Index operator *(void) const
        {
            //if (bitboard == Bitboard(0)) return -1;
            return Bitboard::trailingZeroes(bitboard.bits);
        } 

        inline void operator ++(void)
        {
            // remove LSB
            bitboard.bits &= bitboard.bits - 1;
        }

        inline bool operator !=(const PositionSetIterator& psi) const
        {
            return bitboard != psi.bitboard;
        }
    };
public:
    
    inline PositionSetIterator begin(void) const
    {
        return PositionSetIterator { bitboard };
    }
    inline PositionSetIterator end(void) const
    {
        return PositionSetIterator { 0 };
    }
};


class chessy::MoveGenerator
{
    struct MoveIterator
    {
        inline Move operator *(void) const
        {
            // TODO: implement
        }

        inline void operator ++(void)
        {
            // TODO: implement
        }

        inline bool operator !=(const MoveIterator& psi) const
        {
            // TODO: implement
        }
    };
public:
    MoveGenerator(void);
    //PawnPushProducer generatePawnPushes(void) const;
};



#endif // CHESSY_MOVEGENERATION_H
